function EFFECT:Init(data)
	local pos = data:GetOrigin()
	local norm = data:GetNormal()
	local magnitude = data:GetMagnitude()

	local norepair = data:GetMagnitude() == 0

	local emitter = ParticleEmitter(pos)
	for i=1, math.random(16, 24) do
		local particle = emitter:Add("sprites/glow04_noz", pos)
		particle:SetVelocity((norm + VectorRand()):Normalize() * math.Rand(8, 24))
		particle:SetAirResistance(8)
		if norepair then
			particle:SetColor(255, 0, 0)
			particle:SetEndSize(2)
		else
			particle:SetColor(0, 255, 0)
			particle:SetEndSize(math.Rand(2, 3) * math.max(magnitude, 0.1))
		end
		particle:SetDieTime(math.Rand(0.2, 0.5))
		particle:SetStartSize(0)
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(0)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-8, 8))
	end
end

function EFFECT:Think()
	return false
end

function EFFECT:Render()
end

--[[function EFFECT:Init(data)
	local pos = data:GetOrigin()
	local norm = data:GetNormal()
	local magnitude = data:GetMagnitude()

	self.Pos = pos + norm
	self.Norm = norm
	self.Magnitude = magnitude
	self.DieTime = RealTime() + 0.5
end

function EFFECT:Think()
	return RealTime() < self.DieTime
end

local matRepair = Material("sprites/glow04_noz")
local colRepair = Color(10, 255, 10)
local colNoRepair = Color(255, 0, 0)
local matBeam = Material("trails/laser")
function EFFECT:Render()
	local rt = RealTime()
	local delta = (self.DieTime - rt) * 2

	if self.Magnitude == 0 then
		local size = delta * 14
		render.SetMaterial(matRepair)
		render.DrawQuadEasy(self.Pos, self.Norm, size, size, colNoRepair, rt * 360)
		render.DrawQuadEasy(self.Pos, self.Norm * -1, size, size, colNoRepair, rt * 360)
	else
		local norm = self.Norm
		local pos = self.Pos
		local rotoffset = rt * -180

		for b = 1, 8 do
			local thispos = pos
			local ang = norm:Angle()
			local forward = ang:Forward()
			ang:RotateAroundAxis(forward, b * 45 + rotoffset)

			render.SetMaterial(matBeam)
			render.StartBeam(16)
			render.AddBeam(thispos, 2, 0, colRepair)
			for i = 1, 15 do
				ang:RotateAroundAxis(forward, 6)
				thispos = thispos + delta * (ang:Up() + forward)
				render.AddBeam(thispos, 1.5, i * 0.25, colRepair)
			end
			render.EndBeam()
			render.SetMaterial(matRepair)
			render.DrawSprite(thispos, 3, 3, colRepair)
		end
	end
end
]]
