function EFFECT:Think()
	return false
end

function EFFECT:Render()
end

local function CollideCallback(particle, hitpos, hitnormal)
	if particle:GetDieTime() == 0 then return end
	particle:SetDieTime(0)

	if math.random(1, 3) == 3 then
		WorldSound("physics/flesh/flesh_squishy_impact_hard"..math.random(1, 4)..".wav", hitpos, 50, math.Rand(95, 105))
		util.Decal("Impact.AlienFlesh", hitpos + hitnormal, hitpos - hitnormal)
	end
end

function EFFECT:Init(data)
	local pos = data:GetOrigin()
	local hitnormal = data:GetNormal() * -1

	local r, g, b = render.GetLightRGB(pos)
	r = 10 + r * 20
	g = 60 + g * 185
	b = 10 + b * 20

	local emitter = ParticleEmitter(pos)
	emitter:SetNearClip(40, 50)
	local grav = Vector(0, 0, -500)
	for i = 1, math.random(60, 85) do
		local particle = emitter:Add("particles/smokey", pos)
		particle:SetVelocity(VectorRand():Normalize() * math.Rand(32, 72) + hitnormal * math.Rand(48, 198))
		particle:SetDieTime(math.Rand(0.9, 2.0))
		particle:SetStartAlpha(200)
		particle:SetEndAlpha(0)
		particle:SetStartSize(math.Rand(1, 5))
		particle:SetEndSize(0)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-15, 15))
		particle:SetColor(20, 255, 20)
		particle:SetColor(r * math.Rand(0.8, 1), g * math.Rand(0.8, 1), b * math.Rand(0.8, 1))
		particle:SetGravity(grav)
		particle:SetCollide(true)
		particle:SetCollideCallback(CollideCallback)
	end
	emitter:Finish()

	util.Decal("Impact.AlienFlesh", pos + hitnormal, pos - hitnormal)

	WorldSound("npc/antlion_grub/squashed.wav", pos, 74, math.random(95, 110))
end
