AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

ENT.CleanupPriority = 0

function ENT:Initialize()
	self.m_Health = 50

	self:SetModel("models/Items/battery.mdl")
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:SetCollisionGroup(COLLISION_GROUP_WEAPON)

	self:SetUseType(SIMPLE_USE)

	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:SetMaterial("material")
		phys:EnableMotion(true)
		phys:Wake()
	end

	self:ItemCreated()
end

function ENT:SetBattery(battery)
	self.m_Battery = tonumber(battery) or self:GetBattery()
end

function ENT:GetBattery()
	return self.m_Battery or 120
end

function ENT:Use(activator, caller)
	if activator:IsPlayer() and activator:Alive() and not activator:KeyDown(GAMEMODE.UtilityKey) and activator:Team() ~= TEAM_UNDEAD and not self.Removing then
		if not self.PlacedInMap or not GAMEMODE.MaxFlashlightPickups or (activator.FlashlightPickups or 0) < GAMEMODE.MaxFlashlightPickups or team.NumPlayers(TEAM_HUMAN) <= 1 then
			activator:SetSpareBatteries(activator:GetSpareBatteries() + 1)
			activator:EmitSound("items/battery_pickup.wav")

			activator.FlashlightPickups = (activator.FlashlightPickups or 0) + 1

			self:RemoveNextFrame()
		else
			activator:SplitMessage("<color=red>You decide to leave some for your team.")
		end
	end
end

function ENT:KeyValue(key, value)
	key = string.lower(key)
	if key == "battery" then
		self:SetBattery(tonumber(value))
	end
end

function ENT:OnTakeDamage(dmginfo)
	self:TakePhysicsDamage(dmginfo)

	self.m_Health = self.m_Health - dmginfo:GetDamage()
	if self.m_Health <= 0 then
		self:RemoveNextFrame()
	end
end
