include("shared.lua")

function ENT:Initialize()
	self.BeamColor = Color(0, 255, 0, 255)

	self.ScanningSound = CreateSound(self, "npc/turret_wall/turret_loop1.wav")
	self.ShootingSound = CreateSound(self, "npc/combine_gunship/gunship_weapon_fire_loop6.wav")

	local size = self.SearchDistance + 32
	local nsize = -size
	self:SetRenderBounds(Vector(nsize, nsize, nsize * 0.25), Vector(size, size, size * 0.25))

	self.Emitter = ParticleEmitter(self:GetPos())
	self.Emitter:SetNearClip(24, 32)

	self.NextEmit = 0
end

function ENT:Think()
	if self:GetTurretOwner():IsValid() and self:GetAmmo() > 0 and self:GetMaterial() == "" then
		self.ScanningSound:PlayEx(0.55, 100 + math.sin(CurTime()))
		if self:IsFiring() or self:GetTarget():IsValid() then
			self.ShootingSound:PlayEx(1, 100 + math.cos(CurTime()))
		else
			self.ShootingSound:Stop()
		end
	else
		self.ScanningSound:Stop()
		self.ShootingSound:Stop()
	end

	self.Emitter:SetPos(self:GetPos())
end

function ENT:OnRemove()
	self.ScanningSound:Stop()
	self.ShootingSound:Stop()

	self.Emitter:Finish()
end

function ENT:SetTurretHealth(health)
	self:SetDTFloat(3, health)
end

local smokegravity = Vector(0, 0, 200)
local aScreen = Angle(0, 270, 60)
local vScreen = Vector(0, -2, 45)
function ENT:Draw()
	self:CalculatePoseAngles()
	self:SetPoseParameter("aim_yaw", self.PoseYaw)
	self:SetPoseParameter("aim_pitch", self.PosePitch)

	self:DrawModel()

	local healthpercent = self:GetTurretHealth() / self:GetMaxTurretHealth()

	if healthpercent <= 0.5 and CurTime() >= self.NextEmit then
		self.NextEmit = CurTime() + 0.05

		local particle = self.Emitter:Add("particles/smokey", self:DefaultPos())
		particle:SetStartAlpha(180)
		particle:SetEndAlpha(0)
		particle:SetStartSize(0)
		particle:SetEndSize(math.Rand(8, 32))
		local sat = healthpercent * 360
		particle:SetColor(sat, sat, sat)
		particle:SetVelocity(VectorRand():Normalize() * math.Rand(8, 64))
		particle:SetGravity(smokegravity)
		particle:SetDieTime(math.Rand(0.8, 1.6))
		particle:SetAirResistance(150)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-4, 4))
		particle:SetCollide(true)
		particle:SetBounce(0.2)
	end

	--[[local basepos = self:GetPos()
	if basepos:Distance(EyePos()) <= 1024 then
		local ang = self:GetAngles()
		local right = ang:Right()
		local forward = ang:Forward()
		local pos = basepos + ang:Up() * 32 + right * 2 + forward * -6
		ang:RotateAroundAxis(right, 0) ang:RotateAroundAxis(forward, 90)

		cam.Start3D2D(pos, ang, 0.1)
			surface.SetFont("DefaultBold")
			local y = 0
			local tw, th = surface.GetTextSize("A")

			local ammo = self:GetAmmo()
			if ammo > 0 then
				draw.SimpleText("Ammo: "..ammo.." / "..self.MaxAmmo, "DefaultBold", 0, y, COLOR_WHITE, TEXT_ALIGN_CENTER)
			elseif math.sin(CurTime() * 15) > 0 then
				draw.SimpleText("EMPTY", "DefaultBold", 0, y, COLOR_RED, TEXT_ALIGN_CENTER)
			end
			y = y + th

			draw.SimpleText("Integrity: "..math.ceil(healthpercent * 100).."%", "DefaultBold", 0, y, COLOR_WHITE, TEXT_ALIGN_CENTER)
			y = y + th

			local owner = self:GetTurretOwner()
			if owner:IsValid() then
				draw.SimpleText("["..owner:Name().."]", "DefaultBold", 0, y, COLOR_WHITE, TEXT_ALIGN_CENTER)
			elseif math.sin(CurTime() * 10) > 0 then
				draw.SimpleText("[NO OWNER]", "DefaultBold", 0, y, COLOR_RED, TEXT_ALIGN_CENTER)
			end
		cam.End3D2D()
	end]]

	local owner = self:GetTurretOwner()
	local ammo = self:GetAmmo()
	local flash = math.sin(CurTime() * 15) > 0

	local wid, hei = 128, 92
	cam.Start3D2D(self:LocalToWorld(vScreen), self:LocalToWorldAngles(aScreen), 0.075)

		surface.SetDrawColor(0, 0, 0, 160)
		surface.DrawRect(0, 0, wid, hei)

		surface.SetDrawColor(200, 200, 200, 160)
		surface.DrawRect(0, 0, 8, 16)
		surface.DrawRect(wid - 8, 0, 8, 16)
		surface.DrawRect(8, 0, wid - 16, 8)

		surface.DrawRect(0, hei - 16, 8, 16)
		surface.DrawRect(wid - 8, hei - 16, 8, 16)
		surface.DrawRect(8, hei - 8, wid - 16, 8)

		if owner:IsValid() and owner:IsPlayer() then
			draw.SimpleText(owner:ClippedName(), "Default", wid * 0.5, 10, owner == MySelf and COLOR_BLUE or COLOR_WHITE, TEXT_ALIGN_CENTER, TEXT_ALIGN_TOP)
		end
		draw.SimpleText("Integrity: "..math.ceil(healthpercent * 100).."%", "DefaultBold", wid * 0.5, hei * 0.5, COLOR_WHITE, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)

		if flash and self:GetManualControl() then
			draw.SimpleText("[MANUAL CONTROL]", "Default", wid * 0.5, hei * 0.325, COLOR_YELLOW, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
		end
		
		if ammo > 0 then
			draw.SimpleText("["..ammo.." / "..self.MaxAmmo.."]", "DefaultBold", wid * 0.5, hei - 10, COLOR_WHITE, TEXT_ALIGN_CENTER, TEXT_ALIGN_BOTTOM)
		elseif flash then
			draw.SimpleText("[EMPTY]", "DefaultBold", wid * 0.5, hei - 10, COLOR_RED, TEXT_ALIGN_CENTER, TEXT_ALIGN_BOTTOM)
		end

	cam.End3D2D()
end

local matBeam = Material("effects/laser1")
local matGlow = Material("sprites/glow04_noz")
function ENT:DrawTranslucent()
	if self:GetMaterial() ~= "" then return end

	local lightpos = self:LightPos()

	local ang = self:GetGunAngles()

	local colBeam = self.BeamColor

	local hasowner = self:GetTurretOwner():IsValid()
	local hasammo = self:GetAmmo() > 0
	local manualcontrol = self:GetManualControl()

	local tr = util.TraceLine({start = lightpos, endpos = lightpos + ang:Forward() * (manualcontrol and 4096 or self.SearchDistance), mask = MASK_SHOT, filter = self:GetCachedScanFilter()})

	if not hasowner then
		local rate = FrameTime() * 512
		colBeam.r = math.Approach(colBeam.r, 0, rate)
		colBeam.g = math.Approach(colBeam.g, 0, rate)
		colBeam.b = math.Approach(colBeam.b, 255, rate)
	elseif not hasammo or not manualcontrol and self:GetTarget():IsValid() then
		local rate = FrameTime() * 512
		colBeam.r = math.Approach(colBeam.r, 255, rate)
		colBeam.g = math.Approach(colBeam.g, 0, rate)
		colBeam.b = math.Approach(colBeam.b, 0, rate)
	elseif manualcontrol then
		local rate = FrameTime() * 512
		colBeam.r = math.Approach(colBeam.r, 255, rate)
		colBeam.g = math.Approach(colBeam.g, 255, rate)
		colBeam.b = math.Approach(colBeam.b, 0, rate)
	else
		local rate = FrameTime() * 200
		colBeam.r = math.Approach(colBeam.r, 0, rate)
		colBeam.g = math.Approach(colBeam.g, 255, rate)
		colBeam.b = math.Approach(colBeam.b, 0, rate)
	end

	if hasowner and hasammo then
		render.SetMaterial(matBeam)
		render.DrawBeam(lightpos, tr.HitPos, 1, 0, 1, COLOR_WHITE)
		render.DrawBeam(lightpos, tr.HitPos, 4, 0, 1, colBeam)
		render.SetMaterial(matGlow)
		render.DrawSprite(lightpos, 4, 4, COLOR_WHITE)
		render.DrawSprite(lightpos, 16, 16, colBeam)
		render.DrawSprite(tr.HitPos, 2, 2, COLOR_WHITE)
		render.DrawSprite(tr.HitPos, 8, 8, colBeam)
	else
		render.SetMaterial(matGlow)
		render.DrawSprite(lightpos, 4, 4, COLOR_WHITE)
		render.DrawSprite(lightpos, 16, 16, colBeam)
	end
end
