include("shared.lua")

function ENT:OnRemove()
	local normal = self:GetForward() * -1
	local pos = self:GetPos() + normal

	WorldSound("physics/metal/metal_box_impact_bullet"..math.random(1, 3)..".wav", pos, 75, math.random(90, 110))

	local grav = Vector(0, 0, -300)

	local emitter = ParticleEmitter(pos)
	emitter:SetNearClip(22, 32)
	for i=1, math.random(32, 48) do
		local vNormal = (VectorRand() * 0.6 + normal):Normalize()
		local particle = emitter:Add("effects/spark", pos + vNormal)
		particle:SetVelocity(vNormal * math.Rand(16, 100))
		particle:SetDieTime(math.Rand(0.5, 1))
		particle:SetStartAlpha(255)
		particle:SetEndAlpha(255)
		particle:SetStartSize(math.Rand(0.4, 1.5))
		particle:SetEndSize(0)
		particle:SetRoll(math.Rand(0, 360))
		particle:SetRollDelta(math.Rand(-8, 8))
		particle:SetCollide(true)
		particle:SetBounce(0.8)
		particle:SetGravity(grav)
	end
	emitter:Finish()
end

local matOutlineWhite = Material("white_outline")
local ScaleOutline = 1.4
function ENT:Draw()
	local drawowner = MySelf:IsValid() and MySelf:Team() == TEAM_HUMAN and (MySelf:KeyDown(IN_SPEED) or MySelf:TraceLine(256, MASK_SHOT).HitPos:Distance(self:GetPos()) <= 8)

	if drawowner then
		if self.RenderGroup ~= RENDERGROUP_TRANSLUCENT then
			self.RenderGroup = RENDERGROUP_TRANSLUCENT
		end

		render.SuppressEngineLighting(true)
		render.SetAmbientLight(1, 1, 1)

		local health = self:GetNailHealth() / self:GetMaxNailHealth()
		render.SetColorModulation(1 - health, health, 0)

		local scale = self:GetModelScale()
		self:SetModelScale(scale * ScaleOutline)
		SetMaterialOverride(matOutlineWhite)

		self:DrawModel()

		SetMaterialOverride()
		self:SetModelScale(scale)

		render.SuppressEngineLighting(false)
		render.SetColorModulation(1, 1, 1)
	elseif self.RenderGroup ~= RENDERGROUP_OPAQUE then
		self.RenderGroup = RENDERGROUP_OPAQUE
	end

	self:DrawModel()

	if drawowner then
		local displayowner = self:GetNetworkedString("deployer2", "")
		local owner
		if displayowner == "" then
			displayowner = nil
			local deployeruid = self:GetNetworkedString("deployer", "")
			for _, pl in pairs(player.GetAll()) do
				if pl:UniqueID() == deployeruid then
					owner = pl
					break
				end
			end
		end

		if displayowner or owner and owner:Team() == TEAM_HUMAN then
			local ang = EyeAngles()
			ang:RotateAroundAxis(ang:Up(), -90)
			ang:RotateAroundAxis(ang:Forward(), 90)

			cam.Start3D2D(self:GetPos(), ang, 0.05)
				draw.SimpleText(displayowner or owner:Name(), "ZS3D2DFont", 0, 0, COLOR_GRAY, TEXT_ALIGN_CENTER)
			cam.End3D2D()
		end
	end
end
