ENT.Type = "anim"

function ENT:SetNailHealth(health)
	self:SetDTFloat(0, health)
end

function ENT:SetMaxNailHealth(health)
	self:SetDTFloat(1, health)
	self:SetNailHealth(math.min(health, self:GetNailHealth()))
end

function ENT:GetMaxNailHealth()
	return self:GetDTFloat(1)
end

function ENT:GetNailHealth()
	return self:GetDTFloat(0)
end

function ENT:GetRepairMultiplier()
	return self:GetDTFloat(2)
end

function ENT:SetRepairMultiplier(multiplier)
	return self:SetDTFloat(2, math.max(0, multiplier))
end

function ENT:SetBaseEntity(ent)
	self.m_BaseEntity = ent
end

function ENT:GetBaseEntity()
	return self.m_BaseEntity or NULL
end

function ENT:SetAttachEntity(ent, physbone1, physbone2)
	self.m_AttachEntity = ent

	if not SERVER then return end

	local baseent = self:GetBaseEntity()
	if not baseent:IsValid() then return end

	local cons = constraint.Weld(baseent, ent, physbone1 or 0, physbone2 or 0, 0, true)
	if cons ~= nil then
		for _, oldcons in pairs(constraint.FindConstraints(baseent, "Weld")) do
			if oldcons.Ent1 == ent or oldcons.Ent2 == ent then
				cons = oldcons.Constraint
				break
			end
		end
	end

	cons:DeleteOnRemove(self)
	self:SetNailConstraint(cons)
	if baseent:IsValid() then
		timer.Simple(0.1, GAMEMODE.EvaluatePropFreeze, GAMEMODE, baseent, true)
	elseif ent:IsValid() then
		timer.Simple(0.1, GAMEMODE.EvaluatePropFreeze, GAMEMODE, ent, true)
	end

	if baseent:IsValid() then
		baseent:CollisionRulesChanged()
	end
	if ent and ent:IsValid() then
		ent:CollisionRulesChanged()
	end

	return cons
end

function ENT:GetAttachEntity()
	return self.m_AttachEntity or NULL
end

function ENT:GetActualPos()
	local offset = self:GetActualOffset()
	if offset then
		local parent = self:GetParent()
		if parent:IsValid() then
			return parent:LocalToWorld(offset)
		end
	end

	return self:GetPos()
end

function ENT:GetActualOffset()
	return self.m_ActualOffset
end

function ENT:SetActualOffset(pos, ent)
	self.m_ActualOffset = ent:WorldToLocal(pos)
end
