if SERVER then
	AddCSLuaFile("shared.lua")
end

if CLIENT then
	SWEP.PrintName = "'Zombie Drill' Desert Eagle"
	SWEP.Description = "This high-powered handgun has the ability to pierce through multiple zombies. The bullet's power decreases by half which each zombie it hits."
	SWEP.Slot = 1
	SWEP.SlotPos = 0

	SWEP.HUD3DBone = "v_weapon.Deagle_Slide"
	SWEP.HUD3DPos = Vector(-0.75, 0, 1)
	SWEP.HUD3DAng = Angle(180, 180, 0)

	SWEP.ViewModelFOV = 75
end

SWEP.Base = "weapon_zs_base"

SWEP.HoldType = "pistol"

SWEP.ViewModel = "models/weapons/v_pist_deagle.mdl"
SWEP.WorldModel = "models/weapons/w_pist_deagle.mdl"

SWEP.Primary.Sound = Sound("Weapon_Deagle.Single")
SWEP.Primary.Damage = 42
SWEP.Primary.NumShots = 1
SWEP.Primary.Delay = 0.3

SWEP.Primary.ClipSize = 7
SWEP.Primary.Automatic = false
SWEP.Primary.Ammo = "pistol"
GAMEMODE:SetupDefaultClip(SWEP.Primary)

SWEP.Cone = 0.07
SWEP.ConeMoving = 0.1
SWEP.ConeCrouching = 0.05
SWEP.ConeIron = 0.05
SWEP.ConeIronCrouching = 0.04

SWEP.IronSightsPos = Vector(5.15, 11, 2.7)

local BULLET_NUM = 0
local BulletCallback
function SWEP.BulletCallback(attacker, tr, dmginfo)
	GenericBulletCallback(attacker, tr, dmginfo)

	local ent = tr.Entity
	if ent:IsValid() and ent:IsPlayer() and ent:Team() ~= attacker:Team() and BULLET_NUM <= 4 then
		BULLET_NUM = BULLET_NUM + 1

		local oldsolid = ent:GetSolid()
		ent:SetSolid(SOLID_NONE)

		local dmg = dmginfo:GetDamage() / 2
		attacker:LagCompensation(false)
		attacker:FireBullets({Num = 1, Src = tr.HitPos, Dir = tr.Normal, Spread = Vector(0, 0, 0), Tracer = 1, Force = dmg * 0.15, Damage = dmg, Callback = BulletCallback})
		attacker:LagCompensation(true)

		ent:SetSolid(oldsolid)
	else
		BULLET_NUM = 0
	end
end
BulletCallback = SWEP.BulletCallback
