AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")

include("shared.lua")

function SWEP:Think()
	local prop = self:GetProp()
	if not prop:IsValid() then
		self:Remove()
		return
	end

	self:AlignProp()

	self.BaseClass.Think(self)

	self:NextThink(CurTime())
	return true
end

function SWEP:TransformProp(prop)
	--self._OldMoveType = prop:GetMoveType()
	self._OldSolid = prop:GetSolid()
	self._OldCollisionGroup = prop:GetCollisionGroup()
	local phys = prop:GetPhysicsObject()
	self._OldMoveable = phys and phys:IsValid() and phys:IsMoveable()
	phys:EnableMotion(false)

	phys:AddGameFlag(FVPHYSICS_PLAYER_HELD)
	prop:SetSolid(SOLID_NONE)
	--prop:SetMoveType(MOVETYPE_NONE)
	prop:SetCollisionGroup(COLLISION_GROUP_NONE)
end

function SWEP:UntransformProp(prop)
	--prop:SetMoveType(self._OldMoveType)
	prop:SetSolid(self._OldSolid)
	prop:SetCollisionGroup(self._OldCollisionGroup)
	if self._OldMoveable then
		local phys = prop:GetPhysicsObject()
		if phys:IsValid() then
			phys:ClearGameFlag(FVPHYSICS_PLAYER_HELD)
			phys:EnableMotion(true)
			phys:Wake()
		end
	end
end

function SWEP:OnRemove()
	local prop = self:GetProp()
	if prop:IsValid() then
		self:UntransformProp(prop)
	end

	self.BaseClass.OnRemove(self)
end

function SWEP:Holster()
	local prop = self:GetProp()
	if prop:IsValid() then
		self:UntransformProp(prop)
	end

	if not self.HolsterRemove then
		self.HolsterRemove = true
		self:Remove()
	end

	return true
end
