SWEP.Base = "weapon_zs_basemelee"

SWEP.HoldType = "melee"

SWEP.DamageType = DMG_CLUB

SWEP.ViewModel = "models/weapons/v_crowbar.mdl"
SWEP.WorldModel = "models/weapons/w_crowbar.mdl"

SWEP.MeleeDamage = 20
SWEP.MeleeRange = 64
SWEP.MeleeSize = 2
SWEP.MeleeKnockBack = 0

SWEP.Primary.Delay = 1

SWEP.WalkSpeed = SPEED_NORMAL

SWEP.SwingTime = 0.75
SWEP.SwingHoldType = "grenade"

function SWEP:PlaySwingSound()
	self:EmitSound("weapons/iceaxe/iceaxe_swing1.wav", 75, math.random(35, 45))
end

function SWEP:PlayHitSound()
	self:EmitSound("physics/metal/metal_canister_impact_hard"..math.random(1, 3)..".wav", 75, math.random(86, 90))
end

function SWEP:PlayHitFleshSound()
	self:EmitSound("physics/body/body_medium_break"..math.random(2, 4)..".wav", 75, math.random(86, 90))
end

function SWEP:InitializeModel(prop)
	local phys = prop:GetPhysicsObject()
	if not phys:IsValid() then return end

	local mass = phys:GetMass()
	local mins, maxs = prop:OBBMins(), prop:OBBMaxs()
	local volume = (maxs - mins):Length()

	local xlen = maxs.x - mins.x
	local ylen = maxs.y - mins.y
	local zlen = maxs.z - mins.z

	local maxlen = math.max(zlen, math.max(xlen, ylen))

	self.MeleeDamage = math.Clamp(mass * 0.5, 5, 50)
	self.MeleeRange = math.Clamp(maxlen - 16, 28, 72)
	self.MeleeSize = 2
	self.MeleeKnockBack = math.max((self.MeleeDamage - 30) * 4, 0)
	self.Primary.Delay = 0.5 + self.MeleeDamage * 0.015
	self.WalkSpeed = SPEED_FAST - self.MeleeDamage
	self.SwingTime = self.Primary.Delay * 0.5

	self:SetProp(prop)
	if SERVER then
		self:TransformProp(prop)
	end
end

function SWEP:AlignProp()
	local prop = self:GetProp()
	if not prop:IsValid() then return end

	local owner = self.Owner
	if not owner:IsValid() then return end

	local boneid = owner:LookupBone("ValveBiped.Bip01_R_Hand")
	if boneid and boneid > 0 then
		local pos, ang = owner:GetBonePosition(boneid)
		if pos then
			prop:SetAngles(ang)
			prop:SetPos(pos)
			return
		end
	end

	prop:SetAngles(owner:EyeAngles())
	prop:SetPos(owner:GetShootPos())
end

function SWEP:SetProp(prop) self:SetDTEntity(3, prop) end
function SWEP:GetProp() return self:GetDTEntity(3) end
