include("shared.lua")

SWEP.PrintName = "Wraith"
SWEP.ViewModelFOV = 47

function SWEP:OnRemove()
	if MySelf == self.Owner then
		local vm = MySelf:GetViewModel()
		if vm and vm:IsValid() then
			vm:SetColor(255, 255, 255, 255)
		end
	end

	if self.Owner and self.Owner:IsValid() then
		self.Owner:SetColor(255, 255, 255, 255)
	end

	self.BaseClass.OnRemove(self)
end

function SWEP:Holster()
	if self.Owner == MySelf then
		local vm = MySelf:GetViewModel()
		if vm and vm:IsValid() then
			vm:SetColor(255, 255, 255, 255)
		end
	end

	return self.BaseClass.Holster(self)
end

function SWEP:Think()
	if MySelf == self.Owner then
		local vm = MySelf:GetViewModel()
		if vm and vm:IsValid() then
			if self:IsAttacking() then
				vm:SetColor(20, 20, 20, 200)
			else
				vm:SetColor(20, 20, 20, math.max(25, math.min(MySelf:GetVelocity():Length(), 200)))
			end
		end
	end

	self.BaseClass.Think(self)
end

function SWEP:DrawWorldModel()
	local owner = self.Owner
	if owner:IsValid() then
		if self:IsAttacking() then
			owner:SetColor(200, 200, 200, 180)
		elseif MySelf:IsValid() and MySelf:Team() == TEAM_UNDEAD then
			local eyepos = EyePos()
			owner:SetColor(200, 200, 200, math.Clamp(owner:GetVelocity():Length() - owner:NearestPoint(eyepos):Distance(eyepos) * 0.5, 35, 180))
		else
			local eyepos = EyePos()
			owner:SetColor(200, 200, 200, math.Clamp(owner:GetVelocity():Length() - owner:NearestPoint(eyepos):Distance(eyepos) * 0.5, 1, 180))
		end
	end
end
