if #file.FindInLua(GM.FolderName.."/gamemode/global/cl_noxiousdb.lua") > 0 then
	include("global/cl_noxiousdb.lua")
end

if not MySelf then
	MySelf = NULL
end
hook.Add("Think", "GetLocal", function()
	MySelf = LocalPlayer()
	if MySelf:IsValid() then
		hook.Remove("Think", "GetLocal")
		if not GAMEMODE.HookGetLocal then
			GAMEMODE.HookGetLocal = function(g) end
		end
		gamemode.Call("HookGetLocal", MySelf)
		RunConsoleCommand("PostPlayerInitialSpawn")
	end
end)

-- Sometimes persistent ones don't get created.
local dummy = CreateClientConVar("_zs_dummyconvar", 1, false, false)
local oldCreateClientConVar = CreateClientConVar
function CreateClientConVar(...)
	return oldCreateClientConVar(...) or dummy
end

include("shared.lua")
include("cl_util.lua")
include("cl_options.lua")
include("obj_player_extend_cl.lua")
include("cl_scoreboard.lua")
include("cl_targetid.lua")
include("cl_postprocess.lua")
include("cl_splitmessage.lua")

include("vgui/dgamestate.lua")
include("vgui/dteamcounter.lua")
include("vgui/dzsscoreboard.lua")
include("vgui/dzsplayerpanel.lua")
include("vgui/dmodelpanelex.lua")
include("vgui/dammocounter.lua")

include("vgui/pscoreboard.lua")
include("vgui/poptions.lua")
include("vgui/phelp.lua")
include("vgui/pclasses.lua")
include("vgui/pweapons.lua")
include("vgui/pendboard.lua")
include("vgui/pradialmenu.lua")
include("vgui/pworth.lua")
include("vgui/ppointshop.lua")

include("cl_dermaskin.lua")
include("cl_deathnotice.lua")
include("cl_floatingscore.lua")
include("cl_hint.lua")

w, h = ScrW(), ScrH()

function GM:ClickedPlayerButton(pl, button)
end

function GM:ClickedEndBoardPlayerButton(pl, button)
end

function GM:DrawAmmo(current, maximum, total, screenscale)
	local wid, hei = 200 * screenscale, 64 * screenscale
	local x, y = w - wid - 16, h - hei - 64

	local midhei = y + hei * 0.5

	draw.RoundedBox(8, x, y, wid, hei, color_black_alpha90)
	draw.SimpleText("Ammo", "ZSHUDFontSmall", x + 8, y + 8, COLOR_GRAY, TEXT_ALIGN_LEFT, TEXT_ALIGN_CENTER)

	local col
	if current == 0 then
		col = COLOR_RED
	elseif current <= maximum * 0.5 then
		col = COLOR_YELLOW
	else
		col = COLOR_GRAY
	end
	draw.SimpleText(current, "ZSHUDFont", x + wid - 8, y + 8, col, TEXT_ALIGN_RIGHT)
	draw.SimpleText(maximum, "ZSHUDFont", x + wid - 8, y + 8, col, TEXT_ALIGN_RIGHT)

	if total == 0 then
		draw.SimpleText(total, "ZSHUDFontSmall", x + wid - 8, y + hei - 8, COLOR_RED, TEXT_ALIGN_RIGHT, TEXT_ALIGN_TOP)
	else
		draw.SimpleText(total, "ZSHUDFontSmall", x + wid - 8, y + hei - 8, COLOR_GRAY, TEXT_ALIGN_RIGHT, TEXT_ALIGN_TOP)
	end
end

function GM:TryHumanPickup(pl, entity)
end

function GM:AddExtraOptions(list, window)
end

function GM:SpawnMenuEnabled()
	return false
end

function GM:SpawnMenuOpen()
	return false
end

function GM:ContextMenuOpen()
	return false
end

function GM:HUDWeaponPickedUp(wep)
	if MySelf:Team() == TEAM_HUMAN and not wep.NoPickupNotification then
		self:Rewarded(wep:GetClass())
	end
end

function GM:HUDItemPickedUp(itemname)
end

function GM:HUDAmmoPickedUp(itemname, amount)
end

if not ents.FixedIsValid then
	ents.FixedIsValid = true

	local function check(t)
		local t2 = {}

		for k, v in pairs(t) do
			if v:IsValid() then t2[#t2 + 1] = v end
		end

		return t2
	end

	local oldfindinsphere = ents.FindInSphere
	function ents.FindInSphere(...)
		return check(oldfindinsphere(...))
	end

	local oldfindinbox = ents.FindInBox
	function ents.FindInBox(...)
		return check(oldfindinbox(...))
	end

	local oldfindincone = ents.FindInCone
	function ents.FindInCone(...)
		return check(oldfindincone(...))
	end

	local oldgetall = player.GetAll
	function player.GetAll(...)
		return check(oldgetall(...))
	end
end

function GM:InitPostEntity()
end

local currentpower = 0
local spawngreen = 0
local texFearMeter = surface.GetTextureID("zombiesurvival/fearometer")
local texNeedle = surface.GetTextureID("zombiesurvival/fearometerneedle")
local texEyeGlow = surface.GetTextureID("Sprites/light_glow02_add_noz")
function GM:DrawFearMeter(power, screenscale)
	screenscale = screenscale * 0.5

	if currentpower < power then
		currentpower = math.min(power, currentpower + FrameTime() * (math.tan(currentpower) * 2 + 0.05))
	elseif power < currentpower then
		currentpower = math.max(power, currentpower - FrameTime() * (math.tan(currentpower) * 2 + 0.05))
	end

	local wid, hei = 512 * screenscale, 512 * screenscale
	local mx, my = w * 0.5 - wid * 0.5, h - hei

	surface.SetTexture(texFearMeter)
	surface.SetDrawColor(140, 140, 140, 220)
	surface.DrawTexturedRect(mx, my, wid, hei)

	surface.SetTexture(texNeedle)
	surface.SetDrawColor(160, 160, 160, 220)
	local rot = math.Clamp((0.5 - currentpower) + math.sin(RealTime() * 10) * 0.01, -0.5, 0.5) * 300
	surface.DrawTexturedRectRotated(w * 0.5 - math.max(0, rot * wid * -0.0001), h - hei * 0.5 - math.abs(rot) * hei * 0.00015, wid, hei, rot)

	if MySelf:Team() == TEAM_UNDEAD then
		if not GetGlobalBool("DynamicSpawningDisabled", false) then
			local obs = MySelf:GetObserverTarget()
			spawngreen = math.Approach(spawngreen, self:DynamicSpawnIsValid(obs and obs:IsValid() and obs:IsPlayer() and obs:Team() == TEAM_UNDEAD and obs or MySelf) and 1 or 0, FrameTime() * 4)

			local sy = my + hei * 0.6953
			local size = wid * 0.085

			surface.SetTexture(texEyeGlow)
			surface.SetDrawColor(220 * (1 - spawngreen), 220 * spawngreen, 0, 220)
			surface.DrawTexturedRectRotated(mx + wid * 0.459, sy, size, size)
			surface.DrawTexturedRectRotated(mx + wid * 0.525, sy, size, size)
		end

		--draw.SimpleText("Damage Resistance", "ZSHUDFontTiny", w * 0.5, h - 42, color_white, TEXT_ALIGN_CENTER)
	end
end

GM.LastTimeDead = 0
GM.LastTimeAlive = 0

function GM:TrackLastDeath()
	if MySelf:Alive() then
		self.LastTimeAlive = CurTime()
	else
		self.LastTimeDead = CurTime()
	end
end

local nobaby = CreateClientConVar("zs_nobaby", 0, true, false)
local lastwarntim = -1
GM.HeartBeatTime = 0
GM.FOVLerp = 1
function GM:_Think()
	self:TrackLastDeath()

	local curtime = CurTime()
	local curwav = self:GetWave()

	if curwav <= 0 then
		local timleft = math.max(0, self.WaveZeroLength - curtime)
		if timleft <= 10 and lastwarntim ~= math.ceil(timleft) then
			lastwarntim = math.ceil(timleft)

			if 0 < lastwarntim and not nobaby:GetBool() then
				surface.PlaySound("buttons/lightswitch2.wav")
			end
		end
	elseif self:GetWaveActive() then
		local endtime = self:GetWaveEnd()
		if endtime ~= -1 then
			local timleft = math.max(0, endtime - curtime)
			if timleft <= 10 and lastwarntim ~= math.ceil(timleft) then
				lastwarntim = math.ceil(timleft)

				if 0 < lastwarntim and not nobaby:GetBool() then
					surface.PlaySound("buttons/lightswitch2.wav")
				end
			end
		end
	else
		local start = self:GetWaveStart()
		if start ~= -1 then
			local timleft = math.max(0, start - curtime)
			if timleft <= 10 and lastwarntim ~= math.ceil(timleft) then
				lastwarntim = math.ceil(timleft)

				if 0 < lastwarntim and not nobaby:GetBool() then
					surface.PlaySound("buttons/lightswitch2.wav")
				end
			end
		end
	end

	local myteam = MySelf:Team()

	if not GetGlobalBool("beatsdisabled", false) then
		self:PlayBeats(myteam, self:CachedFearPower())
	end

	if myteam == TEAM_HUMAN then
		self:DoTransparencyRadius()

		local wep = MySelf:GetActiveWeapon()
		if wep:IsValid() and wep.GetIronsights and wep:GetIronsights() then
			self.FOVLerp = math.Approach(self.FOVLerp, wep.IronsightsMultiplier or 0.6, FrameTime() * 4)
		else
			self.FOVLerp = math.Approach(self.FOVLerp, 1, FrameTime() * 5)
		end

		if MySelf:GetBarricadeGhosting() then
			MySelf:BarricadeGhostingThink()
		end
	else
		self.HeartBeatTime = self.HeartBeatTime + (6 + self:CachedFearPower() * 5) * FrameTime()

		if self.ColorModEnabled and MySelf:Alive() and self.m_ZombieVision then
			local dlight = DynamicLight(MySelf:EntIndex())
			if dlight then
				dlight.Pos = EyePos() + EyeAngles():Forward() * 5
				dlight.r = 255
				dlight.g = 255
				dlight.b = 160
				dlight.Brightness = 5
				dlight.Size = 200
				dlight.Decay = 50
				dlight.DieTime = CurTime() + 0.1
			end
		end

		self:TransparencyRadiusResetAll()
	end
end

function GM:ShouldPlayBeats(teamid, fear)
	return not LASTHUMAN and not self.RoundEnded
end

local NextBeat = 0
local LastBeatLevel = 0
function GM:PlayBeats(teamid, fear)
	if fear <= 0 or not self.BeatsEnabled or RealTime() <= NextBeat or not gamemode.Call("ShouldPlayBeats", teamid, fear) then return end

	local beats = self.Beats[teamid == TEAM_HUMAN and self.BeatSetHuman or self.BeatSetZombie]
	if not beats then return end

	LastBeatLevel = math.Approach(LastBeatLevel, math.ceil(fear * 10), 3)

	local snd = beats[LastBeatLevel]
	if snd then
		MySelf:EmitSound(snd, 0) --surface.PlaySound(snd)
		NextBeat = RealTime() + SoundDuration(snd) - 0.025
	end
end

local colHealth = Color(0, 130, 0, 200)
local colPoison = Color(220, 220, 0, 200)
function GM:DrawHealthBar(x, y, health, maxhealth, bartexture, screenscale, poisondamage)
	health = math.max(0, health)

	local wid, hei = 512 * screenscale, 256 * screenscale

	if health > 0 then
		local healthfrac = math.min(1, health / maxhealth)
		local barx = x + screenscale * 72
		local bary = y + screenscale * 100
		local maxbarwidth = screenscale * 402
		local barwidth = maxbarwidth * healthfrac
		colHealth.g = 130 * healthfrac
		colHealth.r = 130 - colHealth.g
		surface.SetDrawColor(colHealth)
		surface.DrawRect(barx, bary, barwidth, screenscale * 24)
		if poisondamage then
			surface.SetDrawColor(colPoison)
			local poisonbarwidth = maxbarwidth * (poisondamage / maxhealth)
			surface.DrawRect(barx + barwidth, bary, math.min(poisonbarwidth, maxbarwidth - barwidth), screenscale * 16)
		end
	end

	surface.SetTexture(bartexture)
	surface.SetDrawColor(150, 150, 150, 200)
	surface.DrawTexturedRect(x, y, wid, hei)

	draw.SimpleText(health, "ZSHUDFont", x + screenscale * 144, y + screenscale * 132, colHealth, TEXT_ALIGN_LEFT)
end

local colPackUp = Color(20, 255, 20, 220)
function GM:DrawPackUpBar(x, y, fraction, screenscale)
	local maxbarwidth = 360 * screenscale
	local barheight = 14 * screenscale
	local barwidth = maxbarwidth * fraction
	local startx = x - maxbarwidth * 0.5

	surface.SetDrawColor(0, 0, 0, 220)
	surface.DrawRect(startx, y, maxbarwidth, barheight)
	surface.SetDrawColor(colPackUp)
	surface.DrawRect(startx + 3, y + 3, barwidth - 6, barheight - 6)
	surface.DrawOutlinedRect(startx, y, maxbarwidth, barheight)

	surface.SetFont("ZSHUDFontSmall")
	local tw, th = surface.GetTextSize("Packing")
	draw.SimpleText("Packing", "ZSHUDFontSmall", x, y - th - 2, colPackUp, TEXT_ALIGN_CENTER)
end

function GM:DrawFlashlightBattery(x, y, current, maximum, screenscale)
	draw.RoundedBox(8, x, y, screenscale * 128, screenscale * 36, color_black_alpha90)

	if current <= 3 then
		surface.SetDrawColor(230, math.abs(math.sin(CurTime() * 3)) * 240, 20, 180)
	else
		surface.SetDrawColor(230, 240, 20, 180)
	end
	surface.DrawRect(x + 8 * screenscale, y + 8 * screenscale, 112 * screenscale * current / maximum, 14 * screenscale)
	surface.SetDrawColor(230, 240, 0, 180)
	surface.DrawOutlinedRect(x + 8 * screenscale, y + 8 * screenscale, 112 * screenscale, 14 * screenscale)

	draw.SimpleText("Flashlight", "DefaultSmall", x + 64 * screenscale, y + 22 * screenscale, COLOR_YELLOW, TEXT_ALIGN_CENTER)

	local spare = MySelf:GetSpareBatteries()
	if spare > 0 then
		draw.SimpleText("Spare: "..spare, "DefaultSmall", x + 64 * screenscale, y + 32 * screenscale, COLOR_YELLOW, TEXT_ALIGN_CENTER)
	end
end

function GM:TransparencyRadiusResetAll()
	for _, pl in pairs(player.GetAll()) do
		self:TransparencyRadiusReset(pl)
	end
end

function GM:TransparencyRadiusReset(pl)
	if pl.m_PreTransAlpha then
		local r, g, b, a = pl:GetColor()
		pl:SetColor(r, g, b, pl.m_PreTransAlpha)
		local wep = pl:GetActiveWeapon()
		if wep:IsValid() then
			local r2, g2, b2, a2 = wep:GetColor()
			wep:SetColor(r2, g2, b2, 255)
		end
		pl.m_PreTransAlpha = nil
	end
end

function GM:DoTransparencyRadius()
	local radius = self.TransparencyRadius

	local mypos = MySelf:GetPos()
	local myteam = MySelf:Team()
	for _, pl in pairs(player.GetAll()) do
		if pl ~= MySelf then
			if pl:Team() == myteam then
				local dist = pl:GetPos():Distance(mypos)
				if dist < radius then
					local newa = math.max(dist / radius * 255, 8)
					local r, g, b, a = pl:GetColor()
					pl:SetColor(r, g, b, newa)
					local wep = pl:GetActiveWeapon()
					if wep:IsValid() then
						local r2, g2, b2, a2 = wep:GetColor()
						wep:SetColor(r2, g2, b2, newa)
					end
					if not pl.m_PreTransAlpha then
						pl.m_PreTransAlpha = a
					end
				else
					self:TransparencyRadiusReset(pl)
				end
			else
				self:TransparencyRadiusReset(pl)
			end
		end
	end
end

local texHumanHealthBar = surface.GetTextureID("zombiesurvival/healthbar__human")
function GM:HumanHUD(screenscale)
	local curtime = CurTime()

	self:DrawHealthBar(screenscale * 24, h - 272 * screenscale, MySelf:Health(), MySelf:GetMaxHealth(), texHumanHealthBar, screenscale, MySelf:GetPoisonDamage())

	local battery = MySelf:GetFlashlightBattery()
	if battery < self.MaxFlashlightBattery then
		self:DrawFlashlightBattery(screenscale * 384, h - 272 * screenscale, battery, self.MaxFlashlightBattery, screenscale)
	end

	local packup = MySelf.PackUp
	if packup and packup:IsValid() then
		self:DrawPackUpBar(w * 0.5, h * 0.55, 1 - packup:GetTimeRemaining() / packup:GetMaxTime(), screenscale)
	end

	if not self.RoundEnded then
		if self:GetWave() == 0 and not self:GetWaveActive() and self.WaveZeroLength >= curtime then
			surface.SetFont("ZSHUDFontSmall")
			local txtw, txth = surface.GetTextSize("Hi")
			draw.SimpleText("Waiting for players... "..string.ToMinutesSeconds(math.max(0, self.WaveZeroLength - curtime)), "ZSHUDFontSmall", w * 0.5, h * 0.25, COLOR_GRAY, TEXT_ALIGN_CENTER)
			draw.SimpleText("The humans closest to zombie spawns will start as zombies.", "ZSHUDFontSmall", w * 0.5, h * 0.25 + txth, COLOR_GRAY, TEXT_ALIGN_CENTER)

			local allplayers = player.GetAll()
			self:SortZombieSpawnDistances(allplayers)
			local desiredzombies = self:GetDesiredStartingZombies()

			draw.SimpleText("Number of initial zombies this game (".. self.WaveOneZombies * 100 .."%): "..desiredzombies, "ZSHUDFontSmall", w * 0.5, h * 0.75, COLOR_GRAY, TEXT_ALIGN_CENTER)

			draw.SimpleText("Zombie volunteers", "ZSHUDFontSmall", w * 0.5, h * 0.75 + txth, COLOR_GRAY, TEXT_ALIGN_CENTER)
			surface.SetFont("ZSHUDFontTiny")
			local y = h * 0.75 + txth * 2
			txtw, txth = surface.GetTextSize("Hi")
			for i, pl in ipairs(allplayers) do
				if h - txth <= y or i > desiredzombies then break else
					draw.SimpleText(pl:Name(), "ZSHUDFontTiny", w * 0.5, y, pl == MySelf and COLOR_RED or COLOR_GRAY, TEXT_ALIGN_CENTER)
					y = y + txth
				end
			end
		end

		local drown = MySelf.status_drown
		if drown and drown:IsValid() then
			surface.SetDrawColor(0, 0, 0, 60)
			surface.DrawRect(w * 0.4, h * 0.35, w * 0.2, 12)
			surface.SetDrawColor(30, 30, 230, 180)
			surface.DrawOutlinedRect(w * 0.4, h * 0.35, w * 0.2, 12)
			surface.DrawRect(w * 0.4, h * 0.35, w * 0.2 * (1 - drown:GetDrown()), 12)
			draw.SimpleText("Breath ", "ZSHUDFontSmall", w * 0.4, h * 0.35 + 6, COLOR_BLUE, TEXT_ALIGN_RIGHT, TEXT_ALIGN_CENTER)
		end
	end

	if gamemode.Call("PlayerCanPurchase", MySelf) then
		if self:GetWaveActive() then
			draw.SimpleText("Press F2 for the Points Shop!", "ZSHUDFontSmall", w * 0.5, 8, COLOR_GRAY, TEXT_ALIGN_CENTER)
		else
			surface.SetFont("ZSHUDFontSmall")
			local tw, th = surface.GetTextSize("W")
			draw.SimpleText("Press F2 for the Points Shop!", "ZSHUDFontSmall", w * 0.5, 8, COLOR_GRAY, TEXT_ALIGN_CENTER)
			draw.SimpleText(self.ArsenalCrateDiscountPercentage.."% discount for buying between waves!", "ZSHUDFontSmall", w * 0.5, 9 + th, COLOR_GRAY, TEXT_ALIGN_CENTER)
		end
	end
end

function GM:CreateItemTooltip(tab)
	local panel = vgui.Create("DPanel")
	panel:SetWide(128)

	local y = 16

	panel:SetTall(y + 16)

	return panel
end

function GM:HUDPaint()
	if not MYSELFVALID or self.FilmMode then return end

	h = ScrH()
	w = ScrW()

	local screenscale = BetterScreenScale()

	local myteam = MySelf:Team()

	-- TargetID
	self:HUDDrawTargetID(myteam, screenscale)

	-- Death Notice
	self:DrawDeathNotice(w - 16, 16, screenscale)

	if self:GetWave() > 0 then
		self:DrawFearMeter(self:CachedFearPower(), screenscale * 0.75)
	end

	if myteam == TEAM_UNDEAD then
		self:ZombieHUD(screenscale * 0.75)
	else
		self:HumanHUD(screenscale * 0.75)
	end
end

function GM:ZombieObserverHUD(MySelf, screenscale, obsmode)
	surface.SetFont("ZSHUDFontSmall")
	local texw, texh = surface.GetTextSize("W")

	local dyn
	if obsmode == OBS_MODE_CHASE then
		local target = MySelf:GetObserverTarget()
		if target and target:IsValid() and target:IsPlayer() and target:Team() == TEAM_UNDEAD then
			draw.SimpleTextBlur("Observing "..target:Name().." ("..math.max(0, target:Health())..")", "ZSHUDFontSmall", w * 0.5, h * 0.75 - texh - 32, COLOR_DARKRED, TEXT_ALIGN_CENTER)
			dyn = not GetGlobalBool("DynamicSpawningDisabled", false) and self:DynamicSpawnIsValid(target)
		end
	end

	if self:GetWaveActive() then
		draw.SimpleTextBlur(dyn and "Press LMB to spawn on top of them" or "Press LMB to spawn", "ZSHUDFontSmall", w * 0.5, h * 0.75, dyn and COLOR_DARKGREEN or COLOR_DARKRED, TEXT_ALIGN_CENTER)
	end
	draw.SimpleTextBlur("Press RMB to cycle targets", "ZSHUDFontSmall", w * 0.5, h * 0.75 + texh + 8, COLOR_DARKRED, TEXT_ALIGN_CENTER)
end

local matHumanHeadID = surface.GetTextureID("zombiesurvival/humanhead")
local matZombieHeadID = surface.GetTextureID("zombiesurvival/zombiehead")
function GM:ZombieHUD(screenscale)
	local realtime = RealTime()

	local classtab = self.ZombieClasses[MySelf:GetZombieClass()]
	self:DrawHealthBar(screenscale * 24, h - 272 * screenscale, MySelf:Health(), classtab.Health, classtab.HealthBar or texHumanHealthBar, screenscale)

	local obsmode = MySelf:GetObserverMode()
	if obsmode ~= OBS_MODE_NONE then
		self:ZombieObserverHUD(MySelf, screenscale, obsmode)
	elseif not self:GetWaveActive() and not MySelf:Alive() then
		local x = w * 0.5
		local y = h * 0.3
		draw.SimpleText("Waiting for the next wave to begin...", "ZSHUDFont", x, y, COLOR_DARKRED, TEXT_ALIGN_CENTER)
		draw.SimpleText("Waiting for the next wave to begin...", "ZSHUDFont", x + math.random(-1, 1), y + math.random(-1, 1), COLOR_DARKRED, TEXT_ALIGN_CENTER)
	end
end

usermessage.Hook("SB", function(um)
	MySelf.Battery = um:ReadFloat()
	MySelf.BatteryBase = um:ReadFloat()
end)

function GM:RequestedDefaultCart()
	local defaultcart = GetConVarString("zs_defaultcart")
	if #defaultcart > 0 then
		defaultcart = string.lower(defaultcart)

		for i, carttab in ipairs(self.SavedCarts) do
			if carttab[1] and string.lower(carttab[1]) == defaultcart then
				gamemode.Call("SuppressArsenalUpgrades", 1)
				RunConsoleCommand("worthcheckout", unpack(carttab[2]))

				return
			end
		end

		RunConsoleCommand("worthrandom")
	end
end

function GM:HookGetLocal()
	MYSELFVALID = true

	MySelf.m_NextSpeedBoost = 0

	MySelf.Battery = MySelf.Battery or self.MaxFlashlightBattery
	MySelf.BatteryBase = MySelf.BatteryBase or 0

	self.Think = self._Think
	self.HUDShouldDraw = self._HUDShouldDraw
	self.RenderScreenspaceEffects = self._RenderScreenspaceEffects
	self.CachedFearPower = self._CachedFearPower
	self.CalcView = self._CalcView
	self.ShouldDrawLocalPlayer = self._ShouldDrawLocalPlayer
	self.PostDrawOpaqueRenderables = self._PostDrawOpaqueRenderables
	self.HUDPaintBackground = self._HUDPaintBackground
	self.CreateMove = self._CreateMove
end

function GM:_HUDShouldDraw(name)
	if self.FilmMode then return false end

	if name == "CHudDamageIndicator" then
		return MySelf:Alive()
	end

	local wep = MySelf:GetActiveWeapon()
	if wep.HUDShouldDraw then
		local ret = wep:HUDShouldDraw(name)
		if ret ~= nil then return ret end
	end

	return name ~= "CHudHealth" and name ~= "CHudBattery" and name ~= "CHudSecondaryAmmo"
end

local Current = 0
local NextCalculate = 0
function GM:_CachedFearPower()
	if CurTime() >= NextCalculate then
		NextCalculate = CurTime() + self.FearMeterRefreshRate
		Current = self:GetFearMeterPower(EyePos(), TEAM_UNDEAD, MySelf)
	end

	return Current
end

function GM:CreateFonts()
	surface.CreateFont("coolvetica", 32, 0, true, false, "ArsenalCrate", false, true)
	surface.CreateFont("coolvetica", 24, 0, true, false, "ArsenalCrate2", false, true)
	surface.CreateFont("csd", 42, 500, true, false, "healthsign", false, true)
	surface.CreateFont("tahoma", 48, 1000, true, false, "zshintfont", false, true)
	surface.CreateFont("typenoksidi", 16, 250, true, false, "ZS3D2DFontTiny", false, true)
	surface.CreateFont("typenoksidi", 22, 400, true, false, "ZS3D2DFontSmaller", false, true)
	surface.CreateFont("typenoksidi", 28, 400, true, false,  "ZS3D2DFontSmall", false, true)
	surface.CreateFont("typenoksidi", 42, 400, true, false, "ZS3D2DFont", false, true)
	surface.CreateFont("typenoksidi", 72, 400, true, false, "ZS3D2DFontBig", false, true)

	local screenscale = BetterScreenScale()

	surface.CreateFont("csd", screenscale * 36, 100, true, false, "zsdeathnoticecs", false, true)
	surface.CreateFont("HL2MP", screenscale * 36, 100, true, false, "zsdeathnotice", false, true)

	surface.CreateFont("typenoksidi", screenscale * 16, 400, true, false, "ZSHUDFontTiny", false, true)
	surface.CreateFont("typenoksidi", screenscale * 20, 400, true, false, "ZSHUDFontSmallest", false, true)
	surface.CreateFont("typenoksidi", screenscale * 22, 400, true, false, "ZSHUDFontSmaller", false, true)
	surface.CreateFont("typenoksidi", screenscale * 28, 400, true, false, "ZSHUDFontSmall", false, true)
	surface.CreateFont("typenoksidi", screenscale * 42, 400, true, false, "ZSHUDFont", false, true)
	surface.CreateFont("typenoksidi", screenscale * 72, 400, true, false, "ZSHUDFontBig", false, true)

	-- Legacy
	surface.CreateFont("typenoksidi", screenscale * 16, 400, true, false, "HUDFontTiny", false, true)
	surface.CreateFont("typenoksidi", screenscale * 20, 400, true, false, "HUDFontSmallest", false, true)
	surface.CreateFont("typenoksidi", screenscale * 22, 400, true, false, "HUDFontSmaller", false, true)
	surface.CreateFont("typenoksidi", screenscale * 28, 400, true, false, "HUDFontSmall", false, true)
	surface.CreateFont("typenoksidi", screenscale * 42, 400, true, false, "HUDFont", false, true)
	surface.CreateFont("typenoksidi", screenscale * 72, 400, true, false, "HUDFontBig", false, true)
end

FontBlurX = 0
FontBlurX2 = 0
FontBlurY = 0
FontBlurY2 = 0

timer.Create("ShuffleNameBlur", 0.1, 0, function()
	FontBlurX = math.random(-8, 8)
	FontBlurX2 = math.random(-8, 8)
	FontBlurY = math.random(-8, 8)
	FontBlurY2 = math.random(-8, 8)
end)

local color_blur1 = Color(60, 60, 60, 220)
local color_blur2 = Color(40, 40, 40, 140)
function draw.SimpleTextBlur(text, font, x, y, col, xalign, yalign)
	color_blur1.a = col.a * 0.85
	color_blur2.a = col.a * 0.55
	draw.SimpleText(text, font, x + FontBlurX, y + FontBlurY, color_blur1, xalign, yalign)
	draw.SimpleText(text, font, x + FontBlurX2, y + FontBlurY2, color_blur2, xalign, yalign)
	draw.SimpleText(text, font, x, y, col, xalign, yalign)
end

function draw.DrawTextBlur(text, font, x, y, col, xalign)
	color_blur1.a = col.a * 0.85
	color_blur2.a = col.a * 0.55
	draw.DrawText(text, font, x + FontBlurX, y + FontBlurY, color_blur1, xalign)
	draw.DrawText(text, font, x + FontBlurX2, y + FontBlurY2, color_blur2, xalign)
	draw.DrawText(text, font, x, y, col, xalign)
end

function GM:CreateVGUI()
	self.GameStatePanel = vgui.Create("DGameState")
	self.GameStatePanel:SetTextFont("ZSHUDFontSmaller")
	self.GameStatePanel:SetAlpha(220)
	self.GameStatePanel:SetSize(320, BetterScreenScale() * 80)
end

function GM:Initialize()
	self:CreateFonts()
	self:PrecacheResources()
	self:CreateVGUI()
	self:InitializeBeats()
end

GM.Beats = {}
function GM:InitializeBeats()
	for _, dirname in pairs(file.FindDir("sound/zombiesurvival/beats/*", true)) do
		if dirname == "none" or dirname == "default" then continue end

		self.Beats[dirname] = {}
		local highestexist
		for i=1, 10 do
			local filename = "zombiesurvival/beats/"..dirname.."/"..i..".wav"
			if file.Exists("sound/"..filename, true) then
				self.Beats[dirname][i] = Sound(filename)
				highestexist = i
			elseif highestexist then
				self.Beats[dirname][i] = "zombiesurvival/beats/"..dirname.."/"..highestexist..".wav"
			end
		end
	end
end

function GM:PlayerDeath(pl, attacker)
end

function GM:OnPlayerHitGround(pl, inwater, hitfloater, speed)
	if pl:Team() == TEAM_UNDEAD or inwater or pl.NoFallDamage then return true end

	if pl:Team() == TEAM_UNDEAD then
		speed = speed - 200
	end

	if pl:Team() ~= TEAM_UNDEAD or not pl.ClassTable.NoFallSlowdown then
		pl:RawCapLegDamage(CurTime() + math.min(2, speed * 0.0035))
	end

	return true
end

usermessage.Hook("reclockedclasses", function(um)
	local str = um:ReadString()
	for classid, state in ipairs(string.Explode(",", str)) do
		local classtab = GAMEMODE.ZombieClasses[classid]
		if classtab then
			state = tonumber(state) or 0
			if state == 1 then -- Forced unlocked.
				classtab.Unlocked = true
				classtab.Locked = nil
			elseif state == 2 then -- Forced locked.
				classtab.Locked = true
				classtab.Unlocked = nil
			else -- Let the game decide.
				classtab.Locked = nil
				classtab.Unlocked = nil
			end
		end
	end
end)

usermessage.Hook("recranfirstzom", function(um)
	GAMEMODE:SplitMessage(h * 0.7, "<color=red><font=ZSHUDFont>You have been randomly chosen to lead the Undead army!</font></color>")
end)

usermessage.Hook("recvolfirstzom", function(um)
	GAMEMODE:SplitMessage(h * 0.7, "<color=red><font=ZSHUDFont>You have volunteered to lead the Undead army!</font></color>")
end)

local cv_ShouldPlayMusic = CreateClientConVar("zs_playmusic", 1, true, false)
local function LoopLastHuman()
	if not GAMEMODE.RoundEnded then
		if cv_ShouldPlayMusic:GetBool() then
			surface.PlaySound(LASTHUMANSOUND)
		end
		timer.Simple(SoundDuration(LASTHUMANSOUND), LoopLastHuman)
	end
end

local function DelayedLH()
	local MySelf = LocalPlayer()

	if not GAMEMODE.RoundEnded then
		if MySelf:Team() == TEAM_UNDEAD or not MySelf:Alive() then
			GAMEMODE:SplitMessage(h * 0.7, "<color=red><font=ZSHUDFont>KILL THE LAST HUMAN!</font></color>")
		else
			GAMEMODE:SplitMessage(h * 0.7, "<color=ltred><font=ZSHUDFont>YOU ARE THE LAST HUMAN!</font></color>", "<color=red><font=ZSHUDFont>"..team.NumPlayers(TEAM_UNDEAD).." ZOMBIES ARE OUT TO GET YOU!</font></color>")
		end
	end
end
function GM:LastHuman(pl)
	self.TheLastHuman = pl

	if not LASTHUMAN then
		LASTHUMAN = true

		RunConsoleCommand("stopsounds")
		timer.Simple(0.5, LoopLastHuman)

		timer.Simple(0.5, DelayedLH)

		self.GetFearMeterPower = function() return 1 end
		self.CachedFearPower = self.GetFearMeterPower
	end
end

function GM:PlayerShouldTakeDamage(pl, attacker)
	return pl == attacker or not attacker:IsPlayer() or pl:Team() ~= attacker:Team() or pl.AllowTK or attacker.AllowTK
end

function GM:SetWave(wave)
	SetGlobalInt("wave", wave)
end

usermessage.Hook("honmention", function(um)
	local id = um:ReadShort()
	local mentionid = um:ReadShort()
	local etc = um:ReadLong()

	local pl = Entity(id)
	if pl and pl:IsValid() and pl:IsPlayer() then
		gamemode.Call("AddHonorableMention", pl, mentionid, etc)
	end
end)

usermessage.Hook("recwavestart", function(um)
	local wave = um:ReadShort()

	gamemode.Call("SetWave", wave)
	gamemode.Call("SetWaveEnd", um:ReadFloat())

	if wave == GAMEMODE:GetNumberOfWaves() then
		GAMEMODE:SplitMessage(h * 0.6, "<color=ltred><font=ZSHUDFont>THE FINAL WAVE HAS BEGUN!", "<color=ltred><font=ZSHUDFontSmall>ALL classes unlocked and the chance for redemption has ended!")
	else
		local UnlockedClasses = {}
		for i, tab in ipairs(GAMEMODE.ZombieClasses) do
			if tab.Wave <= wave and not tab.Unlocked then
				tab.Unlocked = true
				UnlockedClasses[#UnlockedClasses + 1] = tab.Name
			end
		end

		GAMEMODE:SplitMessage(h * 0.6, "<color=ltred><font=ZSHUDFont>Wave "..wave.." has begun!", #UnlockedClasses > 0 and "<color=green><font=ZSHUDFontSmall>"..string.AndSeparate(UnlockedClasses).." unlocked!" or "")
	end

	surface.PlaySound("ambient/creatures/town_zombie_call1.wav")
end)

usermessage.Hook("recwaveend", function(um)
	local wave = um:ReadShort()
	gamemode.Call("SetWaveStart", um:ReadFloat())

	if wave < GAMEMODE:GetNumberOfWaves() then
		GAMEMODE:SplitMessage(h * 0.7, "<color=ltred><font=ZSHUDFont>Wave "..wave.." is over!", "<color=white><font=ZSHUDFontSmall>The Undead have stopped rising and the Points Shop is "..GAMEMODE.ArsenalCrateDiscountPercentage.."% off.")

		surface.PlaySound("ambient/atmosphere/cave_hit"..math.random(1,6)..".wav")
	end
end)

local BloodSplats = {}
function GM:AddRandomBloodSplat()
	local size = math.random(h * 0.2, h * 0.4)
	self:AddBloodSplat(math.random(1, ScrW() - 1), math.random(1, ScrH() - 1), size, size, math.Rand(2, 5))
end

function GM:AddBloodSplat(x, y, w, h, lifetime)
	table.insert(BloodSplats, {x = x, y = y, wid = w, hei = h, Seed = math.Rand(0, 360), RotationRate = math.Rand(-90, 90), EndTime = CurTime() + lifetime, TextureID = surface.GetTextureID("zombiesurvival/screenblood/blood"..math.random(1, 8))})
end

function GM:DrawScreenBlood()
	for k, tab in pairs(BloodSplats) do
		local delta = tab.EndTime - CurTime()
		if delta <= 0 then
			BloodSplats[k] = nil
		else
			surface.SetTexture(tab.TextureID)
			surface.SetDrawColor(255, 255, 255, math.min(255, delta * 255))
			surface.DrawTexturedRectRotated(tab.x, tab.y, tab.wid, tab.hei, tab.Seed + CurTime() * tab.RotationRate)
		end
	end
end

local texFilmGrain = surface.GetTextureID("zombiesurvival/filmgrain/filmgrain")
function GM:_HUDPaintBackground()
	if self.FilmGrainEnabled and MySelf:Team() == TEAM_HUMAN then
		surface.SetTexture(texFilmGrain)
		surface.SetDrawColor(0, 0, 0, (0.25 + 0.75 * self:CachedFearPower()) * self.FilmGrainOpacity)
		surface.DrawTexturedRectUV(0, 0, w, h, 1024, 512)
	end

	--self:DrawScreenBlood()

	local wep = MySelf:GetActiveWeapon()
	if wep:IsValid() and wep.DrawHUDBackground then
		wep:DrawHUDBackground()
	end
end

local function GiveClip()
	RunConsoleCommand("zsgiveammo", 1)
end
local function Give12Clip()
	RunConsoleCommand("zsgiveammo", 0.5)
end
local function Give13Clip()
	RunConsoleCommand("zsgiveammo", 0.3333)
end
local function DropWeapon()
	RunConsoleCommand("zsdropweapon")
end
local function EmptyClip()
	RunConsoleCommand("zsemptyclip")
end
function GM:HumanMenu()
	RadialMenu(w * 0.5, math.min(h * 0.75, h - 256), 256, 256, 0.5 + BetterScreenScale() * 0.5, self.MenuKey,
	"Give clip", GiveClip,
	"Give 1/2 clip", Give12Clip,
	"Give 1/3 clip", Give13Clip,
	"Drop weapon", DropWeapon,
	"Empty clip", EmptyClip)
end

GM.ZombieThirdPerson = false
function GM:PlayerBindPress(pl, bind, wasin)
	if bind == "undo" then
		-- Hold down zoom for a second.
		RunConsoleCommand("+zoom")
		timer.Create("ReleaseZoom", 1, 1, RunConsoleCommand, "-zoom")
	elseif bind == "+menu_context" then
		self.ZombieThirdPerson = not self.ZombieThirdPerson
	end
end

function GM:_ShouldDrawLocalPlayer(pl)
	return pl:Team() == TEAM_UNDEAD and (self.ZombieThirdPerson or pl:CallZombieFunction("ShouldDrawLocalPlayer"))
end

local roll = 0
function GM:_CalcView(pl, origin, angles, fov, znear, zfar)
	if pl.Confusion and pl.Confusion:IsValid() then
		pl.Confusion:CalcView(pl, origin, angles, fov, znear, zfar)
	end

	if pl.Revive and pl.Revive.GetRagdollEyes then
		local rpos, rang = pl.Revive:GetRagdollEyes(pl)
		if rpos then
			origin = rpos
			angles = rang
		end
	elseif pl.KnockedDown then
		local rpos, rang = self:GetRagdollEyes(pl)
		if rpos then
			origin = rpos
			angles = rang
		end
	elseif pl:ShouldDrawLocalPlayer() and pl:OldAlive() then
		origin = pl:GetThirdPersonCameraPos(origin, angles)
	end

	local targetroll = 0
	if self.MovementViewRoll then
		local vel = pl:GetVelocity()
		targetroll = targetroll + vel:GetNormalized():Dot(angles:Right()) * math.min(30, vel:Length() / 100)
	end

	if pl:WaterLevel() >= 3 then
		targetroll = targetroll + math.sin(CurTime()) * 7
	end

	roll = math.Approach(roll, targetroll, math.max(0.25, math.sqrt(math.abs(roll))) * 30 * FrameTime())
	angles.roll = angles.roll + roll

	return self.BaseClass.CalcView(self, pl, origin, angles, fov, znear, zfar)
end

local staggerdir = VectorRand():Normalize()
function GM:_CreateMove(cmd)
	if MySelf:Team() == TEAM_HUMAN then
		if MySelf:Alive() then
			local maxhealth = MySelf:GetMaxHealth()
			local threshold = MySelf:GetPalsy() and maxhealth - 1 or maxhealth * 0.25

			local health = MySelf:Health()
			if health <= threshold then
				local ft = FrameTime()

				staggerdir = (staggerdir + ft * 8 * VectorRand()):Normalize()

				local ang = cmd:GetViewAngles()
				local rate = ft * ((threshold - health) / threshold) * 7
				ang.pitch = math.NormalizeAngle(ang.pitch + staggerdir.z * rate)
				ang.yaw = math.NormalizeAngle(ang.yaw + staggerdir.x * rate)
				cmd:SetViewAngles(ang)
			end
		end
	elseif MySelf.FeignDeath then
		local ang = cmd:GetViewAngles()
		ang.yaw = MySelf.FeignDeath.CommandYaw or ang.yaw
		cmd:SetViewAngles(ang)
	else
		MySelf:CallZombieFunction("CreateMove", cmd)
	end
end

function GM:PostProcessPermitted(str)
	return false
end

function GM:HUDPaintEndRound()
end

function GM:PrePlayerDraw(pl)
	if pl:CallZombieFunction("NoDraw") then return true end
end

function GM:HUDPaintBackgroundEndRound()
	local timleft = math.max(0, self.EndTime + self.EndGameTime - CurTime())
	if timleft <= 0 then
		draw.SimpleText("Loading next map...", "ZSHUDFontSmall", w * 0.5, h * 0.8, COLOR_LIMEGREEN, TEXT_ALIGN_CENTER)
	else
		draw.SimpleText("Next round: "..string.ToMinutesSeconds(timleft), "ZSHUDFontSmall", w * 0.5, h * 0.8, COLOR_WHITE, TEXT_ALIGN_CENTER)
	end

	self:DrawDeathNotice(w - 16, 16, BetterScreenScale())
end

local function EndRoundGetMeleeFilter(self) return {self} end
function GM:EndRound(winner, nextmap)
	if self.RoundEnded then return end
	self.RoundEnded = true

	ROUNDWINNER = winner

	hook.Remove("RenderScreenspaceEffects", "PostProcess")
	self.EndTime = CurTime()

	RunConsoleCommand("stopsounds")

	_R.Player.GetMeleeFilter = EndRoundGetMeleeFilter

	self.HUDPaint = self.HUDPaintEndRound
	self.HUDPaintBackground = self.HUDPaintBackgroundEndRound

	if winner == TEAM_UNDEAD then
		timer.Simple(0.5, surface.PlaySound, ALLLOSESOUND)
	else
		timer.Simple(0.5, surface.PlaySound, HUMANWINSOUND)
	end

	timer.Simple(0.5, MakepEndBoard, winner)
end

function GM:WeaponDeployed(pl, wep)
end

usermessage.Hook("reczsgamestate", function(um)
	gamemode.Call("SetWave", um:ReadShort())
	gamemode.Call("SetWaveStart", um:ReadFloat())
	gamemode.Call("SetWaveEnd", um:ReadFloat())
end)

function GM:LocalPlayerDied(attackername)
	MySelf:SetFlashlightBattery(0)

	LASTDEATH = RealTime()

	surface.PlaySound(DEATHSOUND)
	if attackername then
		self:SplitMessage(h * 0.5, "<color=red><font=ZSHUDFontBig>You have died.</font></color>", "<color=red><font=ZSHUDFont>You were killed by "..tostring(attackername)..".</font></color>")
	else
		self:SplitMessage(h * 0.5, "<color=red><font=ZSHUDFontBig>You have died.</font></color>")
	end
end

function GM:KeyPress(pl, key)
	if key == self.MenuKey and pl:Team() == TEAM_HUMAN and pl:Alive() then
		gamemode.Call("HumanMenu")
	elseif key == IN_SPEED and pl:Alive() then
		if pl:Team() == TEAM_HUMAN then
			pl:DispatchAltUse()
		elseif pl:Team() == TEAM_UNDEAD then
			pl:CallZombieFunction("AltUse")
		end
	end
end

function GM:PlayerCanCheckout(pl)
	return pl:IsValid() and pl:Team() == TEAM_HUMAN and pl:Alive() and self:GetWave() <= 0
end

function GM:OpenWorth()
	if gamemode.Call("PlayerCanCheckout", MySelf) then
		MakepWorth()
	end
end

function GM:CloseWorth()
	if pWorth and pWorth:Valid() then
		pWorth:Remove()
		pWorth = nil
	end
end

GM.SuppressArsenalTime = 0
function GM:SuppressArsenalUpgrades(suppresstime)
	self.SuppressArsenalTime = math.max(CurTime() + suppresstime, self.SuppressArsenalTime)
end

function GM:Rewarded(class, amount)
	if CurTime() < self.SuppressArsenalTime then return end

	class = class or "0"

	--surface.PlaySound("weapons/physcannon/physcannon_charge.wav")

	local wep = weapons.GetStored(class)
	if wep and wep.PrintName then
		self:SplitMessage(h * 0.7, "<color=ltred><font=ZSHUDFontSmall>Arsenal Upgraded</font></color>", "<color=ltred><font=ZSHUDFontSmall>"..wep.PrintName.."</font></color>")
	elseif amount then
		self:SplitMessage(h * 0.7, "<color=ltred><font=ZSHUDFontSmall>Arsenal Upgraded</font></color>", "<color=ltred><font=ZSHUDFontSmall>"..amount.." "..class.."</font></color>")
	else
		self:SplitMessage(h * 0.7, "<color=ltred><font=ZSHUDFontSmall>Arsenal Upgraded</font></color>", "<color=ltred><font=zsdeathnotice>0</font></color>")
	end
end

local FootModelsTime = {}
FootModelsTime["models/zombie/classic.mdl"] = function(pl, iType, bWalking)
	if iType == STEPSOUNDTIME_NORMAL or iType == STEPSOUNDTIME_WATER_FOOT then
		return 625 - pl:GetVelocity():Length()
	elseif iType == STEPSOUNDTIME_ON_LADDER then
		return 600
	elseif iType == STEPSOUNDTIME_WATER_KNEE then
		return 750
	end

	return 450
end

FootModelsTime["models/zombie/fast.mdl"] = function(pl, iType, bWalking)
	if iType == STEPSOUNDTIME_NORMAL or iType == STEPSOUNDTIME_WATER_FOOT then
		return 450 - pl:GetVelocity():Length()
	elseif iType == STEPSOUNDTIME_ON_LADDER then
		return 400
	elseif iType == STEPSOUNDTIME_WATER_KNEE then
		return 550
	end

	return 250
end

FootModelsTime["models/zombie/poison.mdl"] = function(pl, iType, bWalking)
	if iType == STEPSOUNDTIME_NORMAL or iType == STEPSOUNDTIME_WATER_FOOT then
		return 365 - pl:GetVelocity():Length()
	elseif iType == STEPSOUNDTIME_ON_LADDER then
		return 300
	elseif iType == STEPSOUNDTIME_WATER_KNEE then
		return 450
	end

	return 150
end

FootModelsTime["models/headcrabblack.mdl"] = function(pl, iType, bWalking)
	if iType == STEPSOUNDTIME_NORMAL or iType == STEPSOUNDTIME_WATER_FOOT then
		return 285 - pl:GetVelocity():Length()
	elseif iType == STEPSOUNDTIME_ON_LADDER then
		return 200
	elseif iType == STEPSOUNDTIME_WATER_KNEE then
		return 280
	end

	return 175
end

function GM:PlayerStepSoundTime(pl, iType, bWalking)
	local cb = FootModelsTime[pl:GetModel()]
	if cb then
		return cb(pl, iType, bWalking)
	elseif iType == STEPSOUNDTIME_NORMAL or iType == STEPSOUNDTIME_WATER_FOOT then
		return 520 - pl:GetVelocity():Length()
	elseif iType == STEPSOUNDTIME_ON_LADDER then
		return 500
	elseif iType == STEPSOUNDTIME_WATER_KNEE then
		return 650
	end

	return 350
end

local FootModels = {}

FootModels["models/zombie/classic.mdl"] = function(pl, vFootPos, iFoot, strSoundName, fVolume, pFilter)
	if iFoot == 0 then
		if 0.85 < math.sin(RealTime() * 2) then
			pl:EmitSound("Zombie.ScuffLeft")
		else
			pl:EmitSound("Zombie.FootstepLeft")
		end
	else
		if math.sin(RealTime() * 2) < -0.85 then
			pl:EmitSound("Zombie.ScuffRight")
		else
			pl:EmitSound("Zombie.FootstepRight")
		end
	end

	return true
end

FootModels["models/zombie/fast.mdl"] = function(pl, vFootPos, iFoot, strSoundName, fVolume, pFilter)
	if iFoot == 0 then
		pl:EmitSound("NPC_FastZombie.GallopLeft")
	else
		pl:EmitSound("NPC_FastZombie.GallopRight")
	end

	return true
end

FootModels["models/zombie/poison.mdl"] = function(pl, vFootPos, iFoot, strSoundName, fVolume, pFilter)
	if iFoot == 0 and math.random(1,3) < 3 then
		pl:EmitSound("NPC_PoisonZombie.FootstepRight")
	else
		pl:EmitSound("NPC_PoisonZombie.FootstepLeft")
	end

	return true
end

FootModels["models/headcrabblack.mdl"] = function(pl, vFootPos, iFoot, strSoundName, fVolume, pFilter)
	pl:EmitSound("NPC_BlackHeadcrab.Footstep")

	return true
end

FootModels["models/headcrabclassic.mdl"] = function() return true end
FootModels["models/zombie/classic_torso.mdl"] = FootModels["models/headcrabclassic.mdl"]
FootModels["models/wraith_zsv1.mdl"] = FootModels["models/headcrabclassic.mdl"]
FootModels["models/headcrab.mdl"] = FootModels["models/headcrabclassic.mdl"]
FootModels["models/crow.mdl"] = FootModels["models/headcrabclassic.mdl"]

function GM:PlayerFootstep(pl, vFootPos, iFoot, strSoundName, fVolume)
	local cb = FootModels[string.lower(pl:GetModel())]
	if cb then
		return cb(pl, vFootPos, iFoot, strSoundName, fVolume)
	end
end