function GM:CalcMainActivity(ply, velocity)
	ply.CalcIdeal = ACT_MP_STAND_IDLE
	ply.CalcSeqOverride = -1

	if not (ply:CallZombieFunction("CalcMainActivity", velocity) or self:HandlePlayerDriving( ply ) or self:HandlePlayerJumping( ply, velocity ) or self:HandlePlayerDucking( ply, velocity ) or self:HandlePlayerSwimming( ply, velocity ) or self:HandlePlayerVaulting( ply, velocity )) then
		local len2d = velocity:Length2D()

		if len2d > 165 then
			ply.CalcIdeal = ACT_MP_RUN
		elseif len2d > 0.5 then
			ply.CalcIdeal = ACT_MP_WALK
		end
	end
	
	return ply.CalcIdeal, ply.CalcSeqOverride
end

function GM:UpdateAnimation(pl, velocity, maxseqgroundspeed)
	local wep = pl:GetActiveWeapon()
	if wep:IsValid() and wep.UpdateAnimation and wep:UpdateAnimation(pl, velocity, maxseqgroundspeed) then return end

	if pl:Team() == TEAM_HUMAN then
		pl:SetPoseParameter("breathing", 2 - pl:Health() / pl:GetMaxHealth())
		if CLIENT then
			self:GrabEarAnimation(pl)
		end
	elseif pl:CallZombieFunction("UpdateAnimation", velocity, maxseqgroundspeed) then return end

	local len2d = velocity:Length2D()
	if len2d > 0.5 then
		pl:SetPlaybackRate(math.min(len2d / maxseqgroundspeed, 3))
	else
		pl:SetPlaybackRate(1)
	end
end

local CarryingActivityTranslate = {}
CarryingActivityTranslate[ACT_MP_STAND_IDLE] = ACT_HL2MP_IDLE_FIST
CarryingActivityTranslate[ACT_MP_WALK] = ACT_HL2MP_IDLE_FIST + 1
CarryingActivityTranslate[ACT_MP_RUN] = ACT_HL2MP_IDLE_FIST + 2
CarryingActivityTranslate[ACT_MP_CROUCH_IDLE] = ACT_HL2MP_IDLE_FIST + 3
CarryingActivityTranslate[ACT_MP_CROUCHWALK] = ACT_HL2MP_IDLE_FIST + 4
CarryingActivityTranslate[ACT_MP_ATTACK_STAND_PRIMARYFIRE] = ACT_HL2MP_IDLE_FIST + 5
CarryingActivityTranslate[ACT_MP_ATTACK_CROUCH_PRIMARYFIRE] = ACT_HL2MP_IDLE_FIST + 5
CarryingActivityTranslate[ACT_MP_RELOAD_STAND] = ACT_HL2MP_IDLE_FIST + 6
CarryingActivityTranslate[ACT_MP_RELOAD_CROUCH] = ACT_HL2MP_IDLE_FIST + 6
CarryingActivityTranslate[ACT_MP_JUMP] = ACT_HL2MP_IDLE_FIST + 7
CarryingActivityTranslate[ACT_RANGE_ATTACK1] = ACT_HL2MP_IDLE_FIST + 8

function GM:TranslateActivity(pl, act)
	if pl:IsCarrying() then
		return CarryingActivityTranslate[act] or act
	end

	return self.BaseClass:TranslateActivity(pl, act)
end

function GM:DoAnimationEvent(pl, event, data)
	return pl:CallZombieFunction("DoAnimationEvent", event, data) or self.BaseClass:DoAnimationEvent(pl, event, data)
end
