local classid = 1

local function SwitchClass(btn)
	RunConsoleCommand("zs_class", btn.ClassName)
	surface.PlaySound("buttons/button15.wav")
	btn:GetParent():Remove()
end

local function CycleClass(btn)
	classid = btn.ClassID
	MakepClasses(true)
end

function MakepClasses(nofade)
	RunConsoleCommand("_zs_requestlockedclasses")

	LocalPlayer():EmitSound("buttons/lightswitch2.wav", 100, 30)

	if pClasses and pClasses:Valid() then
		pClasses:Close()
		pClasses = nil
	end

	local wid = 320

	local Window = vgui.Create("DFrame")
	Window:SetWide(wid)
	Window:SetDeleteOnClose(true)
	Window:SetKeyboardInputEnabled(false)
	Window:SetTitle(" ")
	pClasses = Window

	local y = 8

	local label = EasyLabel(Window, "Class Select", "ZSHUDFont", color_white)
	label:SetPos(wid * 0.5 - label:GetWide() * 0.5, y)
	y = y + label:GetTall() + 8

	local classtab = GAMEMODE.ZombieClasses[classid]
	if not classtab then
		ErrorNoHalt("pClasses.lua - a class was removed mid-game?")
		return
	end

	local enabled = gamemode.Call("IsClassUnlocked", classid)

	local wb
	if enabled then
		wb = WordBox(Window, tostring(classtab.Name), "ZSHUDFontSmall", COLOR_GREEN)
	else
		wb = WordBox(Window, tostring(classtab.Name), "ZSHUDFontSmall", COLOR_RED)
	end
	wb:SetPos(wid * 0.5 - wb:GetWide() * 0.5, y)
	y = y + wb:GetTall() + 8

	local panel = vgui.Create("DPanel", Window)
	panel:SetSize(136, 136)
	panel:SetPos(wid * 0.5 - panel:GetWide() * 0.5, y)
	if classtab.Icon then
		local icon = vgui.Create("DImage", panel)
		icon:SetImage(classtab.Icon)
		icon:SetSize(panel:GetWide() - 8, panel:GetTall() - 8)
		icon:Center()
	elseif classtab.Model then
		local mdlpanel = vgui.Create("DModelPanelEx", panel)
		mdlpanel:SetModel(classtab.Model)
		mdlpanel:SetAnimated(true)
		mdlpanel:SetAnimSpeed(1)
		mdlpanel:AutoCam()
		mdlpanel:SetSize(panel:GetWide() - 8, panel:GetTall() - 8)
		mdlpanel:Center()
		mdlpanel:SetMouseInputEnabled(false)
	end

	for i = classid - 1, 1, -1 do
		if GAMEMODE.ZombieClasses[i] and not GAMEMODE.ZombieClasses[i].Hidden then
			local prevbutton = EasyButton(Window, "<", 6, 24)
			prevbutton:SetPos(wid * 0.5 - panel:GetWide() * 0.5 - prevbutton:GetWide() - 8, y + panel:GetTall() * 0.5 - prevbutton:GetTall() * 0.5)
			prevbutton.ClassID = i
			prevbutton.DoClick = CycleClass
			break
		end
	end

	for i = classid + 1, #GAMEMODE.ZombieClasses do
		if GAMEMODE.ZombieClasses[i] and not GAMEMODE.ZombieClasses[i].Hidden then
			local nextbutton = EasyButton(Window, ">", 6, 24)
			nextbutton:SetPos(wid * 0.5 + panel:GetWide() * 0.5 + 8, y + panel:GetTall() * 0.5 - nextbutton:GetTall() * 0.5)
			nextbutton.ClassID = i
			nextbutton.DoClick = CycleClass
			break
		end
	end

	y = y + panel:GetTall() + 8

	if not enabled then
		local wb2 = WordBox(Window, "Unlocks on wave "..classtab.Wave, "ZSHUDFontTiny", COLOR_RED)
		wb2:SetPos(wid * 0.5 - wb2:GetWide() * 0.5, y)
		y = y + wb2:GetTall() + 8
	end

	local textentry = vgui.Create("DTextEntry", Window)
	textentry:SetMultiline(true)
	textentry:SetVerticalScrollbarEnabled(true)
	textentry:SetEditable(false)
	textentry:SetSize(wid - 16, 128)
	textentry:SetPos(8, y)
	textentry:SetValue(classtab.Description or "No information available")
	y = y + textentry:GetTall() + 8

	local spawnbutton = EasyButton(Window, "Spawn as a "..tostring(classtab.Name), 8, 4)
	spawnbutton:SetPos(wid * 0.5 - spawnbutton:GetWide() * 0.5, y)
	spawnbutton:SetDisabled(not enabled)
	spawnbutton.ClassName = classtab.Name
	spawnbutton.DoClick = SwitchClass
	y = y + spawnbutton:GetTall() + 8

	local quickselect = vgui.Create("DMultiChoice", Window)
	quickselect:SetWide(24)
	quickselect:SetPos(8, 8)
	quickselect:SetEditable(false)
	quickselect:SetMouseInputEnabled(true)
	for i, tab in ipairs(GAMEMODE.ZombieClasses) do
		if not tab.Hidden then
			quickselect:AddChoice(tab.Name)
		end
	end
	quickselect.OnSelect = function(me, index, value, data)
		surface.PlaySound("buttons/button15.wav")
		RunConsoleCommand("zs_class", value)
		me:GetParent():Remove()
	end

	Window:SetTall(y)
	Window:Center()
	if not nofade then
		Window:SetAlpha(0)
		Window:AlphaTo(255, 0.5)
	end
	Window:MakePopup()
end
