local function emptyfunction() end

local function CheckIfNotHolding(pan)
	if pan.Key and not MySelf:KeyDown(pan.Key) and pan.StartChecking <= CurTime() then
		pan:Remove()
	end
end

local function Close(btn)
	btn:GetParent():Remove()
end

function RadialMenu(x, y, wid, hei, screenscale, key, ...)
	local arg = {...}

	if pRadialMenu then pRadialMenu:Remove() pRadialMenu = nil end

	wid = wid * screenscale
	hei = hei * screenscale

	local panel = vgui.Create("Panel")
	panel.Key = key
	panel.StartChecking = CurTime() + 0.1
	panel.Paint = emptyfunction
	panel.Think = CheckIfNotHolding
	panel:SetSize(wid * 2, hei * 2)
	panel:SetPos(x - wid, y - hei)
	panel:SetMouseInputEnabled(true)
	panel:SetKeyboardInputEnabled(false)
	pRadialMenu = panel

	local angdiv = 360 / math.max(1, math.ceil(#arg * 0.5))

	local ang = Angle(0, 0, 0)

	for i=1, #arg, 2 do
		local button = EasyButton(panel, arg[i], 8, 4)
		if arg[i + 1] then
			button.DoClick = function(btn)
				arg[i + 1](btn)
				--Close(btn)
			end
		else
			button.DoClick = Close
		end
		local forward = ang:Forward()
		button:SetPos(wid + (forward.x * wid * 0.5 - button:GetWide() * 0.5), hei + (forward.y * hei * 0.5 - button:GetTall() * 0.5))

		ang:RotateAroundAxis(Vector(0, 0, 1), angdiv)
	end

	panel:MakePopup()
	timer.Simple(0, gui.SetMousePos, x, y)

	return panel
end
