CLASS.Name = "Chem Zombie"
CLASS.Description = "The Chem Zombie is another mutated zombie that has most of its frail body comprised of volatile, toxic chemicals. It has no other means of attack besides being killed in hopes of blowing up next to any nearby humans."
CLASS.Wave = 1
CLASS.Health = 100
CLASS.SWEP = "weapon_zs_chemzombie"
CLASS.Model = Model("models/Zombie/Poison.mdl")
CLASS.Speed = 160
CLASS.Frags = 3
CLASS.PainSounds = {Sound("npc/metropolice/knockout2.wav")}
CLASS.DeathSounds = {Sound("ambient/fire/gascan_ignite1.wav")}
CLASS.VoicePitch = 0.65

function CLASS:CalcMainActivity(pl, velocity)
	if velocity:Length2D() <= 0.5 then
		pl.CalcIdeal = ACT_IDLE
	else
		pl.CalcSeqOverride = 2
	end

	return true
end

function CLASS:UpdateAnimation(pl, velocity, maxseqgroundspeed)
	pl:FixModelAngles(velocity)
end

if SERVER then
	hook.Add("InitPostEntity", "MakeChemDummy", function()
		DUMMY_CHEMZOMBIE = ents.Create("dummy_chemzombie")
		if DUMMY_CHEMZOMBIE:IsValid() then
			DUMMY_CHEMZOMBIE:Spawn()
		end
	end)

	--local function ChemBomb(pl, refrag)
	local function ChemBomb(pl)
		local pos = pl:LocalToWorld(pl:OBBCenter())

		local effectdata = EffectData()
			effectdata:SetOrigin(pos)
		util.Effect("chemzombieexplode", effectdata, true)

		if DUMMY_CHEMZOMBIE:IsValid() then
			DUMMY_CHEMZOMBIE:SetPos(pos)
		end
		--util.PoisonBlastDamage(DUMMY_CHEMZOMBIE, pl, pos, 190, 70, true)
		util.PoisonBlastDamage(DUMMY_CHEMZOMBIE, pl, pos, 128, 85, true)

		--[[if refrag then
			pl:AddFrags(100)
		end]]

		pl:CheckRedeem()
	end

	function CLASS:OnKilled(pl, attacker, inflictor, suicide, headshot, dmginfo, assister)
		if attacker ~= pl and not suicide then --and not inflictor.IsMelee then
			pl:Gib(dmginfo)
			pl.Gibbed = CurTime()
			timer.Simple(0, ChemBomb, pl)
			--[[if LASTHUMAN then
				timer.Simple(0, ChemBomb, pl, false)
			else
				pl:AddFrags(-100) -- Designed to make it so a person doesn't kill 4 people, redeem, and then any other humans near the blast won't take damage and any zombies nearby will.
				timer.Simple(0, ChemBomb, pl, true)
			end]]

			return true
		end
	end
end

if CLIENT then
	CLASS.HealthBar = surface.GetTextureID("zombiesurvival/healthbar_chemzombie")
	CLASS.Icon = "zombiesurvival/killicons/chemzombie"
end
