CLASS.Name = "Poison Zombie"
CLASS.Description = "This mutated zombie is not only extremely durable but has abnormal strength. In addition to being a behemoth, its body is extremely toxic and will even tear out and toss its own flesh at things too far away to hit."

CLASS.Model = Model("models/Zombie/Poison.mdl")

CLASS.Wave = 2 / 3

CLASS.Health = 400
CLASS.Speed = 150
CLASS.SWEP = "weapon_zs_poisonzombie"

CLASS.Mass = DEFAULT_MASS * 1.5

CLASS.KnockbackScale = 0.1

CLASS.Frags = 7

CLASS.PainSounds = {"NPC_PoisonZombie.Pain"}
CLASS.DeathSounds = {"NPC_PoisonZombie.Die"}
CLASS.VoicePitch = 0.6

function CLASS:CalcMainActivity(pl, velocity)
	if velocity:Length2D() <= 0.5 then
		pl.CalcIdeal = ACT_IDLE
	else
		pl.CalcIdeal = ACT_WALK
	end

	return true
end

function CLASS:DoAnimationEvent(pl, event, data)
	if event == PLAYERANIMEVENT_ATTACK_PRIMARY then
		pl:AnimRestartGesture(GESTURE_SLOT_ATTACK_AND_RELOAD, ACT_MELEE_ATTACK1)
		return ACT_INVALID
	end
end

function CLASS:UpdateAnimation(pl, velocity, maxseqgroundspeed)
	pl:FixModelAngles(velocity)
end

if CLIENT then
	CLASS.HealthBar = surface.GetTextureID("zombiesurvival/healthbar_poisonzombie")
	CLASS.Icon = "zombiesurvival/killicons/poisonzombie"
end
