CLASS.Name = "Wraith"
CLASS.Description = "A zombie or an apparition? Not much is known about it besides the fact that it uses its unique stealth ability and sharp claws to cut things to ribbons."

CLASS.Wave = 1 / 3
CLASS.Health = 80
CLASS.SWEP = "weapon_zs_wraith"
CLASS.Model = Model("models/wraith_zsv1.mdl")
CLASS.Speed = 190

CLASS.Frags = 4

CLASS.VoicePitch = 0.65

CLASS.PainSounds = {Sound("npc/barnacle/barnacle_pull1.wav"), Sound("npc/barnacle/barnacle_pull2.wav"), Sound("npc/barnacle/barnacle_pull3.wav"), Sound("npc/barnacle/barnacle_pull4.wav")}
CLASS.DeathSounds = {Sound("zombiesurvival/wraithdeath1.wav"), Sound("zombiesurvival/wraithdeath2.wav"), Sound("zombiesurvival/wraithdeath3.wav"), Sound("zombiesurvival/wraithdeath4.wav")}

function CLASS:CalcMainActivity(pl, velocity)
	local wep = pl:GetActiveWeapon()
	if wep:IsValid() and wep.IsAttacking and wep:IsAttacking() then
		pl.CalcSeqOverride = 10
	elseif velocity:Length2D() > 0.5 then
		pl.CalcSeqOverride = 3
	else
		pl.CalcSeqOverride = 1
	end

	return true
end

-- The Wraith model doesn't have hitboxes.
function CLASS:ScalePlayerDamage(pl, hitgroup, dmginfo)
	return true
end

function CLASS:UpdateAnimation(pl, velocity, maxseqgroundspeed)
	pl:FixModelAngles(velocity)

	local seq = pl:GetSequence()
	if seq == 10 then
		if not pl.m_PrevFrameCycle then
			pl.m_PrevFrameCycle = true
			pl:SetCycle(0)
		end
	elseif pl.m_PrevFrameCycle then
		pl.m_PrevFrameCycle = nil
	end
end

function CLASS:NoDraw(pl)
	local r, g, b, a = pl:GetColor()
	if a <= 1 then return true end
end

function CLASS:OnKilled(pl, attacker, inflictor, suicide, headshot, dmginfo, assister)
	if SERVER then
		local effectdata = EffectData()
			effectdata:SetOrigin(pl:GetPos())
			effectdata:SetNormal(pl:GetForward())
			effectdata:SetEntity(pl)
		util.Effect("wraithdeath", effectdata, nil, true) -- 4th argument overrides prediction.
	end

	return true -- Don't do default stuff.
end

if CLIENT then
	CLASS.HealthBar = surface.GetTextureID("zombiesurvival/healthbar_wraith")
	CLASS.Icon = "zombiesurvival/killicons/wraith"
end
